#include <ctype.h>
#include <string.h>
#include <conio.h>
#include <unistd.h>
#include <stdio.h>
#include <dir.h>
#include "ymw.h"
#include "mem.h"
#include "FileIO.h"
#include "AutoConv.h"

int AutoConv( int loud )
{
    struct ffblk f;
    WORLD world;
    int conv=0;
    unsigned int ver;
    int done = findfirst("*.ymw", &f, FA_HIDDEN | FA_SYSTEM);

    if( loud ){
      while( !done ) {
        printf("%10u %2u:%02u:%02u %2u/%02u/%4u ",
          (unsigned int )(f.ff_fsize),
          (f.ff_ftime >> 11) & 0x1f,
          (f.ff_ftime >>  5) & 0x3f,
          (f.ff_ftime & 0x1f) * 2,
          (f.ff_fdate >>  5) & 0x0f,
          (f.ff_fdate & 0x1f),
          ((f.ff_fdate >> 9) & 0x7f) + 1980
          );
  
        new_world( &world );

        ver = load_world( f.ff_name, &world );
        printf("%2d.%-2d->%2d.%-2d %27s.", (ver>>16)&0xffff, ver&0xffff, YMW_CURRENT_VERSION, YMW_CURRENT_REVISION, f.ff_name );
       
        unlink( f.ff_name );
        printf(".");
  
        save_world( f.ff_name, &world );
        printf(".");
  
        destroy_world( &world );
        printf(".done\n");
  
        done = findnext(&f);
        }
      }
    else{
      while( !done ) {
        ver = get_world_ver( f.ff_name );
        if( ((ver>>16)&0xffff) != YMW_CURRENT_VERSION ||
            (ver&0xffff)       != YMW_CURRENT_REVISION ){
          if( !conv ){
            printf("YFMudEd AutoConv module\n");
            printf("-----------------------\n");
            printf("    At least one  ymw file in this  directory has  not been\n");
            printf("updated to the current version.   Would you like to convert\n");
            printf("it and all other files in this directory that are not up to\n");
            printf("date?  (y/n)\n\n");
            if( tolower(getch()) == 'y' ) {
              printf("Converting...\n\n");
              conv = -1;
              goto ahd;
              }
            else{
              printf("Skipping conversion...\n\n");
              return 1;
              }
            }
          else{
ahd:        printf("%10u %2u:%02u:%02u %2u/%02u/%4u ",
              (unsigned int )(f.ff_fsize),
              (f.ff_ftime >> 11) & 0x1f,
              (f.ff_ftime >>  5) & 0x3f,
              (f.ff_ftime & 0x1f) * 2,
              (f.ff_fdate >>  5) & 0x0f,
              (f.ff_fdate & 0x1f),
              ((f.ff_fdate >> 9) & 0x7f) + 1980
              );
    
            new_world( &world );

            load_world( f.ff_name, &world );
            printf("%2d.%-2d->%2d.%-2d %27s.", (ver>>16)&0xffff, ver&0xffff, YMW_CURRENT_VERSION, YMW_CURRENT_REVISION, f.ff_name );
           
            unlink( f.ff_name );
            printf(".");
      
            save_world( f.ff_name, &world );
            printf(".");
      
            destroy_world( &world );
            printf(".done\n");
            }
          }
        done = findnext(&f);
        }
      }

    printf("Conversion completed, all files updated...\n\n");

    if( conv ){
      printf("Press any key to continue...\n\n");
      getch();
      }

    return 0;
}
