#include <conio.h>
#include <io.h>
#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include <unistd.h>
#include <allegro.h>
#include "edop.h"
#include "ymw.h"
#include "FileIO.h"
#include "mem.h"

unsigned int get_world_ver( char *fn )
{
    PACKFILE *fh;
    unsigned short ver=0, rev=0;

    if( (fh = pack_fopen( fn, "rbp" )) == NULL )
      return 0;

    pack_fread( &ver, 2, fh );
    pack_fread( &rev, 2, fh );
    pack_fclose( fh );

    return ((ver<<16)|rev);
}

unsigned int load_world( char *fn, WORLD *world )
{
    PACKFILE *fh;
    int j=0, k=0, l=0, m=0, t=0;
    unsigned short ver=0, rev=0;

    if( (fh = pack_fopen( fn, "rbp" )) == NULL )
      return 0;
    pack_fread( &ver, 2, fh );
    pack_fread( &rev, 2, fh );

    switch( ((ver<<16)|rev) ){
      case (1<<16)|13:
           pack_fread( &world->num_zones, 4, fh );
           pack_fread( &world->last_zone_vnum, 4, fh );
           world->zone = malloc( sizeof(ZONE) * world->num_zones );
           for( j = 0; j < world->num_zones; j++ ){
              world->zone[j].name = malloc( NAMESIZE );
              world->zone[j].author = malloc( NAMESIZE );

              memset( world->zone[j].name, 0, NAMESIZE );
              memset( world->zone[j].author, 0, NAMESIZE );

              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].name, l, fh );
       
              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].author, l, fh );
       
              pack_fread( &world->zone[j].tint, 4, fh );
              pack_fread( &world->zone[j].vnum, 4, fh );
              pack_fread( &world->zone[j].life_span, 4, fh );
              pack_fread( &world->zone[j].reset_mode, 4, fh );
       
              pack_fread( &world->zone[j].stype, 4, fh );
              pack_fread( &world->zone[j].rbv, 8, fh );
       
              pack_fread( &world->zone[j].num_rooms, 4, fh );
              pack_fread( &world->zone[j].last_room_vnum, 4, fh );
              world->zone[j].room = malloc( sizeof(ROOM) * world->zone[j].num_rooms );
              for( k = 0; k < world->zone[j].num_rooms; k++ ){
                 world->zone[j].room[k].title = malloc( NAMESIZE );
                 world->zone[j].room[k].desc = malloc( RDSIZE );

                 memset( world->zone[j].room[k].title, 0, NAMESIZE );
                 memset( world->zone[j].room[k].desc, 0, RDSIZE );

                 pack_fread( &world->zone[j].room[k].x, 4, fh );
                 pack_fread( &world->zone[j].room[k].y, 4, fh );
                 pack_fread( &world->zone[j].room[k].z, 4, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].room[k].title, l, fh );
          
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].room[k].desc, l, fh );
          
                 pack_fread( &world->zone[j].room[k].vnum, 4, fh );
                 pack_fread( &world->zone[j].room[k].zone, 4, fh );
                 pack_fread( &world->zone[j].room[k].rbv, 8, fh );
                 pack_fread( &world->zone[j].room[k].stype, 4, fh );
       
                 pack_fread( &world->zone[j].room[k].num_doors, 4, fh );
                 world->zone[j].room[k].door = malloc( sizeof(DOOR) * world->zone[j].room[k].num_doors );
                 for( l = 0; l < world->zone[j].room[k].num_doors; l++ ){
                    world->zone[j].room[k].door[l].desc = malloc( RDSIZE );
                    world->zone[j].room[k].door[l].keywords = malloc( NAMESIZE );

                    memset( world->zone[j].room[k].door[l].desc, 0, RDSIZE );
                    memset( world->zone[j].room[k].door[l].keywords, 0, NAMESIZE );

                    pack_fread( &world->zone[j].room[k].door[l].croom, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].czone, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].cdir, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].typea, 2, fh );
                    pack_fread( &world->zone[j].room[k].door[l].typeb, 2, fh );
                    pack_fread( &world->zone[j].room[k].door[l].dir, 4, fh );
       
                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].door[l].desc, m, fh );
       
                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].door[l].keywords, m, fh );
                    }
          
                 pack_fread( &world->zone[j].room[k].num_exd, 4, fh );
                 world->zone[j].room[k].exd = malloc( sizeof(EXD) * world->zone[j].room[k].num_exd );
                 for( l = 0; l < world->zone[j].room[k].num_exd; l++ ){
                    world->zone[j].room[k].exd[l].keywords = malloc( NAMESIZE );
                    world->zone[j].room[k].exd[l].desc = malloc( RDSIZE );

                    memset( world->zone[j].room[k].exd[l].keywords, 0, NAMESIZE );
                    memset( world->zone[j].room[k].exd[l].desc, 0, RDSIZE );

                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].exd[l].keywords, m, fh );
          
                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].exd[l].desc, m, fh );
                    }
                 world->zone[j].room[k].num_cont = 0;
                 world->zone[j].room[k].content = malloc( 1 );
                 }
       
              pack_fread( &world->zone[j].num_objects, 4, fh );
              pack_fread( &world->zone[j].last_object_vnum, 4, fh );
              world->zone[j].object = malloc( sizeof(OBJECT) * world->zone[j].num_objects );
              for( k = 0; k < world->zone[j].num_objects; k++ ){
                 world->zone[j].object[k].keywords = malloc( NAMESIZE );
                 world->zone[j].object[k].short_desc = malloc( NAMESIZE );
                 world->zone[j].object[k].long_desc = malloc( NAMESIZE );
                 world->zone[j].object[k].action_desc = malloc( NAMESIZE );

                 memset( world->zone[j].object[k].keywords, 0, NAMESIZE );
                 memset( world->zone[j].object[k].short_desc, 0, NAMESIZE );
                 memset( world->zone[j].object[k].long_desc, 0, NAMESIZE );
                 memset( world->zone[j].object[k].action_desc, 0, NAMESIZE );

                 pack_fread( &world->zone[j].object[k].vnum, 4, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].keywords, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].short_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].long_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].action_desc, l, fh );
       
                 pack_fread( &world->zone[j].object[k].type, 4, fh );
                 pack_fread( &world->zone[j].object[k].ebv, 8, fh );
                 pack_fread( &world->zone[j].object[k].wbv, 8, fh );
                 pack_fread( world->zone[j].object[k].value, 16, fh );
                 pack_fread( &world->zone[j].object[k].weight, 4, fh );
                 pack_fread( &world->zone[j].object[k].cost, 4, fh );
                 pack_fread( &world->zone[j].object[k].rpd, 4, fh );
                 pack_fread( &world->zone[j].object[k].num_exd, 4, fh );
                 world->zone[j].object[k].exd = malloc( sizeof(EXD) * world->zone[j].object[k].num_exd );
                 for( m = 0; m < world->zone[j].object[k].num_exd; m++ ){
                    world->zone[j].object[k].exd[m].keywords = malloc( NAMESIZE );
                    world->zone[j].object[k].exd[m].desc = malloc( RDSIZE );

                    memset( world->zone[j].object[k].exd[m].keywords, 0, NAMESIZE );
                    memset( world->zone[j].object[k].exd[m].desc, 0, RDSIZE );

                    pack_fread( &l, 4, fh );
                    pack_fread( world->zone[j].object[k].exd[m].keywords, l, fh );
       
                    pack_fread( &l, 4, fh );
                    pack_fread( world->zone[j].object[k].exd[m].desc, l, fh );
                    }
                 pack_fread( &world->zone[j].object[k].num_affect, 4, fh );
                 world->zone[j].object[k].affect = malloc( sizeof(OAFFECT) * world->zone[j].object[k].num_affect );
                 for( m = 0; m < world->zone[j].object[k].num_affect; m++ ){
                    pack_fread( &world->zone[j].object[k].affect[m].location, 4, fh );
                    pack_fread( &world->zone[j].object[k].affect[m].value, 4, fh );
                    }
                 }
       
              pack_fread( &world->zone[j].num_mobiles, 4, fh );
              pack_fread( &world->zone[j].last_mobile_vnum, 4, fh );
              world->zone[j].mobile = malloc( sizeof(MOBILE) * world->zone[j].num_mobiles );
              for( k = 0; k < world->zone[j].num_mobiles; k++ ){
                 world->zone[j].mobile[k].keywords = malloc( NAMESIZE );
                 world->zone[j].mobile[k].short_desc = malloc( NAMESIZE );
                 world->zone[j].mobile[k].long_desc = malloc( NAMESIZE );
                 world->zone[j].mobile[k].detail_desc = malloc( RDSIZE );

                 memset( world->zone[j].mobile[k].keywords, 0, NAMESIZE );
                 memset( world->zone[j].mobile[k].short_desc, 0, NAMESIZE );
                 memset( world->zone[j].mobile[k].long_desc, 0, NAMESIZE );
                 memset( world->zone[j].mobile[k].detail_desc, 0, RDSIZE );

                 pack_fread( &world->zone[j].mobile[k].vnum, 4, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].keywords, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].short_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].long_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].detail_desc, l, fh );
       
                 pack_fread( &world->zone[j].mobile[k].actbv, 8, fh );
                 world->zone[j].mobile[k].actbv &= ~(1<<3);
                 pack_fread( &world->zone[j].mobile[k].affbv, 8, fh );
                 pack_fread( &world->zone[j].mobile[k].alignment, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].typeflag, 1, fh );
                 pack_fread( &world->zone[j].mobile[k].level, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].thac0, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].ac, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].mhpx, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].mhpy, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].mhpz, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].bhdx, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].bhdy, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].bhdz, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].gold, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].exp, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].loadpos, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].defpos, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].sex, 1, fh );
                 pack_fread( &world->zone[j].mobile[k].num_especs, 4, fh );
                 world->zone[j].mobile[k].espec = malloc( sizeof(ESPEC) * world->zone[j].mobile[k].num_especs );
                 pack_fread( world->zone[j].mobile[k].espec, sizeof(ESPEC)*world->zone[j].mobile[k].num_especs, fh );
                 }

              world->zone[j].num_shops = 0;
              world->zone[j].shop = malloc( 1 );
              world->zone[j].last_shop_vnum = -1;

              pack_fread( &world->zone[j].num_tags, 4, fh );
              world->zone[j].tag = malloc( sizeof(TAG) * world->zone[j].num_tags );
              for( k = 0; k < world->zone[j].num_tags; k++ ){
                 world->zone[j].tag[k].str = malloc( NAMESIZE );

                 memset( world->zone[j].tag[k].str, 0, NAMESIZE );

                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].tag[k].str, l, fh );
          
                 pack_fread( &world->zone[j].tag[k].x, 4, fh );
                 pack_fread( &world->zone[j].tag[k].y, 4, fh );
                 pack_fread( &world->zone[j].tag[k].z, 4, fh );
                 }
              }
           pack_fclose( fh );
           rehash_world( world );
           break;

      case (1<<16)|14:
           pack_fread( &world->num_zones, 4, fh );
           pack_fread( &world->last_zone_vnum, 4, fh );
           world->zone = malloc( sizeof(ZONE) * world->num_zones );
           for( j = 0; j < world->num_zones; j++ ){
              world->zone[j].name = malloc( NAMESIZE );
              world->zone[j].author = malloc( NAMESIZE );

              memset( world->zone[j].name, 0, NAMESIZE );
              memset( world->zone[j].author, 0, NAMESIZE );

              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].name, l, fh );
       
              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].author, l, fh );
       
              pack_fread( &world->zone[j].tint, 4, fh );
              pack_fread( &world->zone[j].vnum, 4, fh );
              pack_fread( &world->zone[j].life_span, 4, fh );
              pack_fread( &world->zone[j].reset_mode, 4, fh );
       
              pack_fread( &world->zone[j].stype, 4, fh );
              pack_fread( &world->zone[j].rbv, 8, fh );
       
              pack_fread( &world->zone[j].num_rooms, 4, fh );
              pack_fread( &world->zone[j].last_room_vnum, 4, fh );
              world->zone[j].room = malloc( sizeof(ROOM) * world->zone[j].num_rooms );
              for( k = 0; k < world->zone[j].num_rooms; k++ ){
                 world->zone[j].room[k].title = malloc( NAMESIZE );
                 world->zone[j].room[k].desc = malloc( RDSIZE );

                 memset( world->zone[j].room[k].title, 0, NAMESIZE );
                 memset( world->zone[j].room[k].desc, 0, RDSIZE );

                 pack_fread( &world->zone[j].room[k].x, 4, fh );
                 pack_fread( &world->zone[j].room[k].y, 4, fh );
                 pack_fread( &world->zone[j].room[k].z, 4, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].room[k].title, l, fh );
          
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].room[k].desc, l, fh );
          
                 pack_fread( &world->zone[j].room[k].vnum, 4, fh );
                 pack_fread( &world->zone[j].room[k].zone, 4, fh );
                 pack_fread( &world->zone[j].room[k].rbv, 8, fh );
                 pack_fread( &world->zone[j].room[k].stype, 4, fh );
       
                 pack_fread( &world->zone[j].room[k].num_doors, 4, fh );
                 world->zone[j].room[k].door = malloc( sizeof(DOOR) * world->zone[j].room[k].num_doors );
                 for( l = 0; l < world->zone[j].room[k].num_doors; l++ ){
                    world->zone[j].room[k].door[l].desc = malloc( RDSIZE );
                    world->zone[j].room[k].door[l].keywords = malloc( NAMESIZE );

                    memset( world->zone[j].room[k].door[l].desc, 0, RDSIZE );
                    memset( world->zone[j].room[k].door[l].keywords, 0, NAMESIZE );

                    pack_fread( &world->zone[j].room[k].door[l].croom, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].czone, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].cdir, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].typea, 2, fh );
                    pack_fread( &world->zone[j].room[k].door[l].typeb, 2, fh );
                    world->zone[j].room[k].door[l].state = 0;
                    world->zone[j].room[k].door[l].key = -1;
                    pack_fread( &world->zone[j].room[k].door[l].dir, 4, fh );
       
                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].door[l].desc, m, fh );
       
                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].door[l].keywords, m, fh );
                    }
          
                 pack_fread( &world->zone[j].room[k].num_exd, 4, fh );
                 world->zone[j].room[k].exd = malloc( sizeof(EXD) * world->zone[j].room[k].num_exd );
                 for( l = 0; l < world->zone[j].room[k].num_exd; l++ ){
                    world->zone[j].room[k].exd[l].keywords = malloc( NAMESIZE );
                    world->zone[j].room[k].exd[l].desc = malloc( RDSIZE );

                    memset( world->zone[j].room[k].exd[l].keywords, 0, NAMESIZE );
                    memset( world->zone[j].room[k].exd[l].desc, 0, RDSIZE );

                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].exd[l].keywords, m, fh );
          
                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].exd[l].desc, m, fh );
                    }
                 world->zone[j].room[k].num_cont = 0;
                 world->zone[j].room[k].content = malloc( 1 );
                 }
       
              pack_fread( &world->zone[j].num_objects, 4, fh );
              pack_fread( &world->zone[j].last_object_vnum, 4, fh );
              world->zone[j].object = malloc( sizeof(OBJECT) * world->zone[j].num_objects );
              for( k = 0; k < world->zone[j].num_objects; k++ ){
                 world->zone[j].object[k].keywords = malloc( NAMESIZE );
                 world->zone[j].object[k].short_desc = malloc( NAMESIZE );
                 world->zone[j].object[k].long_desc = malloc( NAMESIZE );
                 world->zone[j].object[k].action_desc = malloc( NAMESIZE );

                 memset( world->zone[j].object[k].keywords, 0, NAMESIZE );
                 memset( world->zone[j].object[k].short_desc, 0, NAMESIZE );
                 memset( world->zone[j].object[k].long_desc, 0, NAMESIZE );
                 memset( world->zone[j].object[k].action_desc, 0, NAMESIZE );

                 pack_fread( &world->zone[j].object[k].vnum, 4, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].keywords, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].short_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].long_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].action_desc, l, fh );
       
                 pack_fread( &world->zone[j].object[k].type, 4, fh );
                 pack_fread( &world->zone[j].object[k].ebv, 8, fh );
                 pack_fread( &world->zone[j].object[k].wbv, 8, fh );
                 pack_fread( world->zone[j].object[k].value, 16, fh );
                 pack_fread( &world->zone[j].object[k].weight, 4, fh );
                 pack_fread( &world->zone[j].object[k].cost, 4, fh );
                 pack_fread( &world->zone[j].object[k].rpd, 4, fh );
                 pack_fread( &world->zone[j].object[k].num_exd, 4, fh );
                 world->zone[j].object[k].exd = malloc( sizeof(EXD) * world->zone[j].object[k].num_exd );
                 for( m = 0; m < world->zone[j].object[k].num_exd; m++ ){
                    world->zone[j].object[k].exd[m].keywords = malloc( NAMESIZE );
                    world->zone[j].object[k].exd[m].desc = malloc( RDSIZE );

                    memset( world->zone[j].object[k].exd[m].keywords, 0, NAMESIZE );
                    memset( world->zone[j].object[k].exd[m].desc, 0, RDSIZE );

                    pack_fread( &l, 4, fh );
                    pack_fread( world->zone[j].object[k].exd[m].keywords, l, fh );
       
                    pack_fread( &l, 4, fh );
                    pack_fread( world->zone[j].object[k].exd[m].desc, l, fh );
                    }
                 pack_fread( &world->zone[j].object[k].num_affect, 4, fh );
                 world->zone[j].object[k].affect = malloc( sizeof(OAFFECT) * world->zone[j].object[k].num_affect );
                 for( m = 0; m < world->zone[j].object[k].num_affect; m++ ){
                    pack_fread( &world->zone[j].object[k].affect[m].location, 4, fh );
                    pack_fread( &world->zone[j].object[k].affect[m].value, 4, fh );
                    }
                 }
       
              pack_fread( &world->zone[j].num_mobiles, 4, fh );
              pack_fread( &world->zone[j].last_mobile_vnum, 4, fh );
              world->zone[j].mobile = malloc( sizeof(MOBILE) * world->zone[j].num_mobiles );
              for( k = 0; k < world->zone[j].num_mobiles; k++ ){
                 world->zone[j].mobile[k].keywords = malloc( NAMESIZE );
                 world->zone[j].mobile[k].short_desc = malloc( NAMESIZE );
                 world->zone[j].mobile[k].long_desc = malloc( NAMESIZE );
                 world->zone[j].mobile[k].detail_desc = malloc( RDSIZE );

                 memset( world->zone[j].mobile[k].keywords, 0, NAMESIZE );
                 memset( world->zone[j].mobile[k].short_desc, 0, NAMESIZE );
                 memset( world->zone[j].mobile[k].long_desc, 0, NAMESIZE );
                 memset( world->zone[j].mobile[k].detail_desc, 0, RDSIZE );

                 pack_fread( &world->zone[j].mobile[k].vnum, 4, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].keywords, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].short_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].long_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].detail_desc, l, fh );
       
                 pack_fread( &world->zone[j].mobile[k].actbv, 8, fh );
                 world->zone[j].mobile[k].actbv &= ~(1<<3);
                 pack_fread( &world->zone[j].mobile[k].affbv, 8, fh );
                 pack_fread( &world->zone[j].mobile[k].alignment, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].typeflag, 1, fh );
                 pack_fread( &world->zone[j].mobile[k].level, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].thac0, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].ac, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].mhpx, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].mhpy, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].mhpz, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].bhdx, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].bhdy, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].bhdz, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].gold, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].exp, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].loadpos, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].defpos, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].sex, 1, fh );
                 pack_fread( &world->zone[j].mobile[k].num_especs, 4, fh );
                 world->zone[j].mobile[k].espec = malloc( sizeof(ESPEC) * world->zone[j].mobile[k].num_especs );
                 pack_fread( world->zone[j].mobile[k].espec, sizeof(ESPEC)*world->zone[j].mobile[k].num_especs, fh );
                 }

              pack_fread( &world->zone[j].num_shops, 4, fh );
              world->zone[j].shop = malloc( sizeof(SHOP)*world->zone[j].num_shops );
              pack_fread( &world->zone[j].last_shop_vnum, 4, fh );
              for( k = 0; k < world->zone[j].num_shops; k++ ){
                 world->zone[j].shop[k].buy_item_ne = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].buy_item_ne, 0, NAMESIZE );

                 world->zone[j].shop[k].sell_item_ne = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].sell_item_ne, 0, NAMESIZE );

                 world->zone[j].shop[k].refuse_offer = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].refuse_offer, 0, NAMESIZE );

                 world->zone[j].shop[k].shop_afford = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].shop_afford, 0, NAMESIZE );

                 world->zone[j].shop[k].play_afford = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].play_afford, 0, NAMESIZE );

                 world->zone[j].shop[k].buy_success = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].buy_success, 0, NAMESIZE );

                 world->zone[j].shop[k].sell_success = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].sell_success, 0, NAMESIZE );

                 pack_fread( &world->zone[j].shop[k].vnum, 4, fh );
       
                 pack_fread( &world->zone[j].shop[k].num_items, 4, fh );
                 world->zone[j].shop[k].item = malloc( 4*world->zone[j].shop[k].num_items );
                 pack_fread( world->zone[j].shop[k].item, 4*world->zone[j].shop[k].num_items, fh );
       
                 pack_fread( &world->zone[j].shop[k].prof_sell, 4, fh );
                 pack_fread( &world->zone[j].shop[k].prof_buy, 4, fh );
       
                 pack_fread( &world->zone[j].shop[k].num_bspecs, 4, fh );
                 world->zone[j].shop[k].bspec = malloc( sizeof(BSPEC)*world->zone[j].shop[k].num_bspecs );
                 for( l = 0; l < world->zone[j].shop[k].num_bspecs; l++ ){
                    world->zone[j].shop[k].bspec[l].namelist = malloc( NAMESIZE );
                    memset( world->zone[j].shop[k].bspec[l].namelist, 0, NAMESIZE );

                    pack_fread( &world->zone[j].shop[k].bspec[l].type, 4, fh );
       
                    pack_fread( &t, 4, fh );
                    pack_fread( world->zone[j].shop[k].bspec[l].namelist, t, fh );
                    }
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].buy_item_ne, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].sell_item_ne, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].refuse_offer, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].shop_afford, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].play_afford, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].buy_success, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].sell_success, t, fh );
       
                 pack_fread( &world->zone[j].shop[k].temper, 4, fh );
                 pack_fread( &world->zone[j].shop[k].shop_bv, 8, fh );
                 pack_fread( &world->zone[j].shop[k].mobile, 4, fh );
                 pack_fread( &world->zone[j].shop[k].withwho_bv, 8, fh );
       
                 pack_fread( &world->zone[j].shop[k].num_rooms, 4, fh );
                 world->zone[j].shop[k].room = malloc( 4*world->zone[j].shop[k].num_rooms );
                 pack_fread( world->zone[j].shop[k].room, 4*world->zone[j].shop[k].num_rooms, fh );
       
                 pack_fread( &world->zone[j].shop[k].topen[0], 4, fh );
                 pack_fread( &world->zone[j].shop[k].tclose[0], 4, fh );
                 pack_fread( &world->zone[j].shop[k].topen[1], 4, fh );
                 pack_fread( &world->zone[j].shop[k].tclose[1], 4, fh );
                 }

              pack_fread( &world->zone[j].num_tags, 4, fh );
              world->zone[j].tag = malloc( sizeof(TAG) * world->zone[j].num_tags );
              for( k = 0; k < world->zone[j].num_tags; k++ ){
                 world->zone[j].tag[k].str = malloc( NAMESIZE );

                 memset( world->zone[j].tag[k].str, 0, NAMESIZE );

                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].tag[k].str, l, fh );
          
                 pack_fread( &world->zone[j].tag[k].x, 4, fh );
                 pack_fread( &world->zone[j].tag[k].y, 4, fh );
                 pack_fread( &world->zone[j].tag[k].z, 4, fh );
                 }
              }
           pack_fclose( fh );
           rehash_world( world );
           break;

      case (1<<16)|15:
           pack_fread( &world->num_zones, 4, fh );
           pack_fread( &world->last_zone_vnum, 4, fh );
           world->zone = malloc( sizeof(ZONE) * world->num_zones );
           for( j = 0; j < world->num_zones; j++ ){
              world->zone[j].name = malloc( NAMESIZE );
              world->zone[j].author = malloc( NAMESIZE );

              memset( world->zone[j].name, 0, NAMESIZE );
              memset( world->zone[j].author, 0, NAMESIZE );

              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].name, l, fh );
       
              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].author, l, fh );
       
              pack_fread( &world->zone[j].tint, 4, fh );
              pack_fread( &world->zone[j].vnum, 4, fh );
              pack_fread( &world->zone[j].life_span, 4, fh );
              pack_fread( &world->zone[j].reset_mode, 4, fh );
       
              pack_fread( &world->zone[j].stype, 4, fh );
              pack_fread( &world->zone[j].rbv, 8, fh );
       
              pack_fread( &world->zone[j].num_rooms, 4, fh );
              pack_fread( &world->zone[j].last_room_vnum, 4, fh );
              world->zone[j].room = malloc( sizeof(ROOM) * world->zone[j].num_rooms );
              for( k = 0; k < world->zone[j].num_rooms; k++ ){
                 world->zone[j].room[k].title = malloc( NAMESIZE );
                 world->zone[j].room[k].desc = malloc( RDSIZE );

                 memset( world->zone[j].room[k].title, 0, NAMESIZE );
                 memset( world->zone[j].room[k].desc, 0, RDSIZE );

                 pack_fread( &world->zone[j].room[k].x, 4, fh );
                 pack_fread( &world->zone[j].room[k].y, 4, fh );
                 pack_fread( &world->zone[j].room[k].z, 4, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].room[k].title, l, fh );
          
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].room[k].desc, l, fh );
          
                 pack_fread( &world->zone[j].room[k].vnum, 4, fh );
                 pack_fread( &world->zone[j].room[k].zone, 4, fh );
                 pack_fread( &world->zone[j].room[k].rbv, 8, fh );
                 pack_fread( &world->zone[j].room[k].stype, 4, fh );
       
                 pack_fread( &world->zone[j].room[k].num_doors, 4, fh );
                 world->zone[j].room[k].door = malloc( sizeof(DOOR) * world->zone[j].room[k].num_doors );
                 for( l = 0; l < world->zone[j].room[k].num_doors; l++ ){
                    world->zone[j].room[k].door[l].desc = malloc( RDSIZE );
                    world->zone[j].room[k].door[l].keywords = malloc( NAMESIZE );

                    memset( world->zone[j].room[k].door[l].desc, 0, RDSIZE );
                    memset( world->zone[j].room[k].door[l].keywords, 0, NAMESIZE );

                    pack_fread( &world->zone[j].room[k].door[l].croom, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].czone, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].cdir, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].typea, 2, fh );
                    pack_fread( &world->zone[j].room[k].door[l].typeb, 2, fh );
                    world->zone[j].room[k].door[l].state = 0;
                    world->zone[j].room[k].door[l].key = -1;
                    pack_fread( &world->zone[j].room[k].door[l].dir, 4, fh );
       
                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].door[l].desc, m, fh );
       
                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].door[l].keywords, m, fh );
                    }
          
                 pack_fread( &world->zone[j].room[k].num_exd, 4, fh );
                 world->zone[j].room[k].exd = malloc( sizeof(EXD) * world->zone[j].room[k].num_exd );
                 for( l = 0; l < world->zone[j].room[k].num_exd; l++ ){
                    world->zone[j].room[k].exd[l].keywords = malloc( NAMESIZE );
                    world->zone[j].room[k].exd[l].desc = malloc( RDSIZE );

                    memset( world->zone[j].room[k].exd[l].keywords, 0, NAMESIZE );
                    memset( world->zone[j].room[k].exd[l].desc, 0, RDSIZE );

                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].exd[l].keywords, m, fh );
          
                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].exd[l].desc, m, fh );
                    }

                 pack_fread( &world->zone[j].room[k].num_cont, 4, fh );
                 world->zone[j].room[k].content = malloc( sizeof(RCONTENT)*world->zone[j].room[k].num_cont );
                 pack_fread( world->zone[j].room[k].content, sizeof(RCONTENT)*world->zone[j].room[k].num_cont, fh );
                 for( l = 0; l < world->zone[j].room[k].num_cont; l++ )
                    if( world->zone[j].room[k].content[l].ifflag )
                      world->zone[j].room[k].content[l].ifflag = 1;
                 }
       
              pack_fread( &world->zone[j].num_objects, 4, fh );
              pack_fread( &world->zone[j].last_object_vnum, 4, fh );
              world->zone[j].object = malloc( sizeof(OBJECT) * world->zone[j].num_objects );
              for( k = 0; k < world->zone[j].num_objects; k++ ){
                 world->zone[j].object[k].keywords = malloc( NAMESIZE );
                 world->zone[j].object[k].short_desc = malloc( NAMESIZE );
                 world->zone[j].object[k].long_desc = malloc( NAMESIZE );
                 world->zone[j].object[k].action_desc = malloc( NAMESIZE );

                 memset( world->zone[j].object[k].keywords, 0, NAMESIZE );
                 memset( world->zone[j].object[k].short_desc, 0, NAMESIZE );
                 memset( world->zone[j].object[k].long_desc, 0, NAMESIZE );
                 memset( world->zone[j].object[k].action_desc, 0, NAMESIZE );

                 pack_fread( &world->zone[j].object[k].vnum, 4, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].keywords, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].short_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].long_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].action_desc, l, fh );
       
                 pack_fread( &world->zone[j].object[k].type, 4, fh );
                 pack_fread( &world->zone[j].object[k].ebv, 8, fh );
                 pack_fread( &world->zone[j].object[k].wbv, 8, fh );
                 pack_fread( world->zone[j].object[k].value, 16, fh );
                 pack_fread( &world->zone[j].object[k].weight, 4, fh );
                 pack_fread( &world->zone[j].object[k].cost, 4, fh );
                 pack_fread( &world->zone[j].object[k].rpd, 4, fh );
                 pack_fread( &world->zone[j].object[k].num_exd, 4, fh );
                 world->zone[j].object[k].exd = malloc( sizeof(EXD) * world->zone[j].object[k].num_exd );
                 for( m = 0; m < world->zone[j].object[k].num_exd; m++ ){
                    world->zone[j].object[k].exd[m].keywords = malloc( NAMESIZE );
                    world->zone[j].object[k].exd[m].desc = malloc( RDSIZE );

                    memset( world->zone[j].object[k].exd[m].keywords, 0, NAMESIZE );
                    memset( world->zone[j].object[k].exd[m].desc, 0, RDSIZE );

                    pack_fread( &l, 4, fh );
                    pack_fread( world->zone[j].object[k].exd[m].keywords, l, fh );
       
                    pack_fread( &l, 4, fh );
                    pack_fread( world->zone[j].object[k].exd[m].desc, l, fh );
                    }
                 pack_fread( &world->zone[j].object[k].num_affect, 4, fh );
                 world->zone[j].object[k].affect = malloc( sizeof(OAFFECT) * world->zone[j].object[k].num_affect );
                 for( m = 0; m < world->zone[j].object[k].num_affect; m++ ){
                    pack_fread( &world->zone[j].object[k].affect[m].location, 4, fh );
                    pack_fread( &world->zone[j].object[k].affect[m].value, 4, fh );
                    }
                 }
       
              pack_fread( &world->zone[j].num_mobiles, 4, fh );
              pack_fread( &world->zone[j].last_mobile_vnum, 4, fh );
              world->zone[j].mobile = malloc( sizeof(MOBILE) * world->zone[j].num_mobiles );
              for( k = 0; k < world->zone[j].num_mobiles; k++ ){
                 world->zone[j].mobile[k].keywords = malloc( NAMESIZE );
                 world->zone[j].mobile[k].short_desc = malloc( NAMESIZE );
                 world->zone[j].mobile[k].long_desc = malloc( NAMESIZE );
                 world->zone[j].mobile[k].detail_desc = malloc( RDSIZE );

                 memset( world->zone[j].mobile[k].keywords, 0, NAMESIZE );
                 memset( world->zone[j].mobile[k].short_desc, 0, NAMESIZE );
                 memset( world->zone[j].mobile[k].long_desc, 0, NAMESIZE );
                 memset( world->zone[j].mobile[k].detail_desc, 0, RDSIZE );

                 pack_fread( &world->zone[j].mobile[k].vnum, 4, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].keywords, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].short_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].long_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].detail_desc, l, fh );
       
                 pack_fread( &world->zone[j].mobile[k].actbv, 8, fh );
                 world->zone[j].mobile[k].actbv &= ~(1<<3);
                 pack_fread( &world->zone[j].mobile[k].affbv, 8, fh );
                 pack_fread( &world->zone[j].mobile[k].alignment, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].typeflag, 1, fh );
                 pack_fread( &world->zone[j].mobile[k].level, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].thac0, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].ac, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].mhpx, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].mhpy, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].mhpz, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].bhdx, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].bhdy, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].bhdz, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].gold, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].exp, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].loadpos, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].defpos, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].sex, 1, fh );
                 pack_fread( &world->zone[j].mobile[k].num_especs, 4, fh );
                 world->zone[j].mobile[k].espec = malloc( sizeof(ESPEC) * world->zone[j].mobile[k].num_especs );
                 pack_fread( world->zone[j].mobile[k].espec, sizeof(ESPEC)*world->zone[j].mobile[k].num_especs, fh );
                 }

              pack_fread( &world->zone[j].num_shops, 4, fh );
              world->zone[j].shop = malloc( sizeof(SHOP)*world->zone[j].num_shops );
              pack_fread( &world->zone[j].last_shop_vnum, 4, fh );
              for( k = 0; k < world->zone[j].num_shops; k++ ){
                 world->zone[j].shop[k].buy_item_ne = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].buy_item_ne, 0, NAMESIZE );

                 world->zone[j].shop[k].sell_item_ne = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].sell_item_ne, 0, NAMESIZE );

                 world->zone[j].shop[k].refuse_offer = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].refuse_offer, 0, NAMESIZE );

                 world->zone[j].shop[k].shop_afford = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].shop_afford, 0, NAMESIZE );

                 world->zone[j].shop[k].play_afford = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].play_afford, 0, NAMESIZE );

                 world->zone[j].shop[k].buy_success = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].buy_success, 0, NAMESIZE );

                 world->zone[j].shop[k].sell_success = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].sell_success, 0, NAMESIZE );

                 pack_fread( &world->zone[j].shop[k].vnum, 4, fh );
       
                 pack_fread( &world->zone[j].shop[k].num_items, 4, fh );
                 world->zone[j].shop[k].item = malloc( 4*world->zone[j].shop[k].num_items );
                 pack_fread( world->zone[j].shop[k].item, 4*world->zone[j].shop[k].num_items, fh );
       
                 pack_fread( &world->zone[j].shop[k].prof_sell, 4, fh );
                 pack_fread( &world->zone[j].shop[k].prof_buy, 4, fh );
       
                 pack_fread( &world->zone[j].shop[k].num_bspecs, 4, fh );
                 world->zone[j].shop[k].bspec = malloc( sizeof(BSPEC)*world->zone[j].shop[k].num_bspecs );
                 for( l = 0; l < world->zone[j].shop[k].num_bspecs; l++ ){
                    world->zone[j].shop[k].bspec[l].namelist = malloc( NAMESIZE );
                    memset( world->zone[j].shop[k].bspec[l].namelist, 0, NAMESIZE );

                    pack_fread( &world->zone[j].shop[k].bspec[l].type, 4, fh );
       
                    pack_fread( &t, 4, fh );
                    pack_fread( world->zone[j].shop[k].bspec[l].namelist, t, fh );
                    }
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].buy_item_ne, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].sell_item_ne, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].refuse_offer, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].shop_afford, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].play_afford, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].buy_success, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].sell_success, t, fh );
       
                 pack_fread( &world->zone[j].shop[k].temper, 4, fh );
                 pack_fread( &world->zone[j].shop[k].shop_bv, 8, fh );
                 pack_fread( &world->zone[j].shop[k].mobile, 4, fh );
                 pack_fread( &world->zone[j].shop[k].withwho_bv, 8, fh );
       
                 pack_fread( &world->zone[j].shop[k].num_rooms, 4, fh );
                 world->zone[j].shop[k].room = malloc( 4*world->zone[j].shop[k].num_rooms );
                 pack_fread( world->zone[j].shop[k].room, 4*world->zone[j].shop[k].num_rooms, fh );
       
                 pack_fread( &world->zone[j].shop[k].topen[0], 4, fh );
                 pack_fread( &world->zone[j].shop[k].tclose[0], 4, fh );
                 pack_fread( &world->zone[j].shop[k].topen[1], 4, fh );
                 pack_fread( &world->zone[j].shop[k].tclose[1], 4, fh );
                 }

              pack_fread( &world->zone[j].num_tags, 4, fh );
              world->zone[j].tag = malloc( sizeof(TAG) * world->zone[j].num_tags );
              for( k = 0; k < world->zone[j].num_tags; k++ ){
                 world->zone[j].tag[k].str = malloc( NAMESIZE );

                 memset( world->zone[j].tag[k].str, 0, NAMESIZE );

                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].tag[k].str, l, fh );
          
                 pack_fread( &world->zone[j].tag[k].x, 4, fh );
                 pack_fread( &world->zone[j].tag[k].y, 4, fh );
                 pack_fread( &world->zone[j].tag[k].z, 4, fh );
                 }
              }
           pack_fclose( fh );
           rehash_world( world );
           break;

      case (1<<16)|16:
           pack_fread( &world->num_zones, 4, fh );
           pack_fread( &world->last_zone_vnum, 4, fh );
           world->zone = malloc( sizeof(ZONE) * world->num_zones );
           for( j = 0; j < world->num_zones; j++ ){
              world->zone[j].name = malloc( NAMESIZE );
              world->zone[j].author = malloc( NAMESIZE );

              memset( world->zone[j].name, 0, NAMESIZE );
              memset( world->zone[j].author, 0, NAMESIZE );

              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].name, l, fh );
       
              pack_fread( &l, 4, fh );
              pack_fread( world->zone[j].author, l, fh );
       
              pack_fread( &world->zone[j].tint, 4, fh );
              pack_fread( &world->zone[j].vnum, 4, fh );
              pack_fread( &world->zone[j].life_span, 4, fh );
              pack_fread( &world->zone[j].reset_mode, 4, fh );
       
              pack_fread( &world->zone[j].stype, 4, fh );
              pack_fread( &world->zone[j].rbv, 8, fh );
       
              pack_fread( &world->zone[j].num_rooms, 4, fh );
              pack_fread( &world->zone[j].last_room_vnum, 4, fh );
              world->zone[j].room = malloc( sizeof(ROOM) * world->zone[j].num_rooms );
              for( k = 0; k < world->zone[j].num_rooms; k++ ){
                 world->zone[j].room[k].title = malloc( NAMESIZE );
                 world->zone[j].room[k].desc = malloc( RDSIZE );

                 memset( world->zone[j].room[k].title, 0, NAMESIZE );
                 memset( world->zone[j].room[k].desc, 0, RDSIZE );

                 pack_fread( &world->zone[j].room[k].x, 4, fh );
                 pack_fread( &world->zone[j].room[k].y, 4, fh );
                 pack_fread( &world->zone[j].room[k].z, 4, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].room[k].title, l, fh );
          
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].room[k].desc, l, fh );
          
                 pack_fread( &world->zone[j].room[k].vnum, 4, fh );
                 pack_fread( &world->zone[j].room[k].zone, 4, fh );
                 pack_fread( &world->zone[j].room[k].rbv, 8, fh );
                 pack_fread( &world->zone[j].room[k].stype, 4, fh );
       
                 pack_fread( &world->zone[j].room[k].num_doors, 4, fh );
                 world->zone[j].room[k].door = malloc( sizeof(DOOR) * world->zone[j].room[k].num_doors );
                 for( l = 0; l < world->zone[j].room[k].num_doors; l++ ){
                    world->zone[j].room[k].door[l].desc = malloc( RDSIZE );
                    world->zone[j].room[k].door[l].keywords = malloc( NAMESIZE );

                    memset( world->zone[j].room[k].door[l].desc, 0, RDSIZE );
                    memset( world->zone[j].room[k].door[l].keywords, 0, NAMESIZE );

                    pack_fread( &world->zone[j].room[k].door[l].croom, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].czone, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].cdir, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].typea, 2, fh );
                    pack_fread( &world->zone[j].room[k].door[l].typeb, 2, fh );
                    pack_fread( &world->zone[j].room[k].door[l].state, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].key, 4, fh );
                    pack_fread( &world->zone[j].room[k].door[l].dir, 4, fh );
       
                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].door[l].desc, m, fh );
       
                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].door[l].keywords, m, fh );
                    }
          
                 pack_fread( &world->zone[j].room[k].num_exd, 4, fh );
                 world->zone[j].room[k].exd = malloc( sizeof(EXD) * world->zone[j].room[k].num_exd );
                 for( l = 0; l < world->zone[j].room[k].num_exd; l++ ){
                    world->zone[j].room[k].exd[l].keywords = malloc( NAMESIZE );
                    world->zone[j].room[k].exd[l].desc = malloc( RDSIZE );

                    memset( world->zone[j].room[k].exd[l].keywords, 0, NAMESIZE );
                    memset( world->zone[j].room[k].exd[l].desc, 0, RDSIZE );

                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].exd[l].keywords, m, fh );
          
                    pack_fread( &m, 4, fh );
                    pack_fread( world->zone[j].room[k].exd[l].desc, m, fh );
                    }

                 pack_fread( &world->zone[j].room[k].num_cont, 4, fh );
                 world->zone[j].room[k].content = malloc( sizeof(RCONTENT)*world->zone[j].room[k].num_cont );
                 pack_fread( world->zone[j].room[k].content, sizeof(RCONTENT)*world->zone[j].room[k].num_cont, fh );
                 for( l = 0; l < world->zone[j].room[k].num_cont; l++ )
                    if( world->zone[j].room[k].content[l].ifflag )
                      world->zone[j].room[k].content[l].ifflag = 1;
                 }
       
              pack_fread( &world->zone[j].num_objects, 4, fh );
              pack_fread( &world->zone[j].last_object_vnum, 4, fh );
              world->zone[j].object = malloc( sizeof(OBJECT) * world->zone[j].num_objects );
              for( k = 0; k < world->zone[j].num_objects; k++ ){
                 world->zone[j].object[k].keywords = malloc( NAMESIZE );
                 world->zone[j].object[k].short_desc = malloc( NAMESIZE );
                 world->zone[j].object[k].long_desc = malloc( NAMESIZE );
                 world->zone[j].object[k].action_desc = malloc( NAMESIZE );

                 memset( world->zone[j].object[k].keywords, 0, NAMESIZE );
                 memset( world->zone[j].object[k].short_desc, 0, NAMESIZE );
                 memset( world->zone[j].object[k].long_desc, 0, NAMESIZE );
                 memset( world->zone[j].object[k].action_desc, 0, NAMESIZE );

                 pack_fread( &world->zone[j].object[k].vnum, 4, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].keywords, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].short_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].long_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].object[k].action_desc, l, fh );
       
                 pack_fread( &world->zone[j].object[k].type, 4, fh );
                 pack_fread( &world->zone[j].object[k].ebv, 8, fh );
                 pack_fread( &world->zone[j].object[k].wbv, 8, fh );
                 pack_fread( world->zone[j].object[k].value, 16, fh );
                 pack_fread( &world->zone[j].object[k].weight, 4, fh );
                 pack_fread( &world->zone[j].object[k].cost, 4, fh );
                 pack_fread( &world->zone[j].object[k].rpd, 4, fh );
                 pack_fread( &world->zone[j].object[k].num_exd, 4, fh );
                 world->zone[j].object[k].exd = malloc( sizeof(EXD) * world->zone[j].object[k].num_exd );
                 for( m = 0; m < world->zone[j].object[k].num_exd; m++ ){
                    world->zone[j].object[k].exd[m].keywords = malloc( NAMESIZE );
                    world->zone[j].object[k].exd[m].desc = malloc( RDSIZE );

                    memset( world->zone[j].object[k].exd[m].keywords, 0, NAMESIZE );
                    memset( world->zone[j].object[k].exd[m].desc, 0, RDSIZE );

                    pack_fread( &l, 4, fh );
                    pack_fread( world->zone[j].object[k].exd[m].keywords, l, fh );
       
                    pack_fread( &l, 4, fh );
                    pack_fread( world->zone[j].object[k].exd[m].desc, l, fh );
                    }
                 pack_fread( &world->zone[j].object[k].num_affect, 4, fh );
                 world->zone[j].object[k].affect = malloc( sizeof(OAFFECT) * world->zone[j].object[k].num_affect );
                 for( m = 0; m < world->zone[j].object[k].num_affect; m++ ){
                    pack_fread( &world->zone[j].object[k].affect[m].location, 4, fh );
                    pack_fread( &world->zone[j].object[k].affect[m].value, 4, fh );
                    }
                 }
       
              pack_fread( &world->zone[j].num_mobiles, 4, fh );
              pack_fread( &world->zone[j].last_mobile_vnum, 4, fh );
              world->zone[j].mobile = malloc( sizeof(MOBILE) * world->zone[j].num_mobiles );
              for( k = 0; k < world->zone[j].num_mobiles; k++ ){
                 world->zone[j].mobile[k].keywords = malloc( NAMESIZE );
                 world->zone[j].mobile[k].short_desc = malloc( NAMESIZE );
                 world->zone[j].mobile[k].long_desc = malloc( NAMESIZE );
                 world->zone[j].mobile[k].detail_desc = malloc( RDSIZE );

                 memset( world->zone[j].mobile[k].keywords, 0, NAMESIZE );
                 memset( world->zone[j].mobile[k].short_desc, 0, NAMESIZE );
                 memset( world->zone[j].mobile[k].long_desc, 0, NAMESIZE );
                 memset( world->zone[j].mobile[k].detail_desc, 0, RDSIZE );

                 pack_fread( &world->zone[j].mobile[k].vnum, 4, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].keywords, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].short_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].long_desc, l, fh );
       
                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].mobile[k].detail_desc, l, fh );
       
                 pack_fread( &world->zone[j].mobile[k].actbv, 8, fh );
                 world->zone[j].mobile[k].actbv &= ~(1<<3);
                 pack_fread( &world->zone[j].mobile[k].affbv, 8, fh );
                 pack_fread( &world->zone[j].mobile[k].alignment, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].typeflag, 1, fh );
                 pack_fread( &world->zone[j].mobile[k].level, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].thac0, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].ac, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].mhpx, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].mhpy, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].mhpz, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].bhdx, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].bhdy, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].bhdz, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].gold, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].exp, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].loadpos, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].defpos, 4, fh );
                 pack_fread( &world->zone[j].mobile[k].sex, 1, fh );
                 pack_fread( &world->zone[j].mobile[k].num_especs, 4, fh );
                 world->zone[j].mobile[k].espec = malloc( sizeof(ESPEC) * world->zone[j].mobile[k].num_especs );
                 pack_fread( world->zone[j].mobile[k].espec, sizeof(ESPEC)*world->zone[j].mobile[k].num_especs, fh );
                 }

              pack_fread( &world->zone[j].num_shops, 4, fh );
              world->zone[j].shop = malloc( sizeof(SHOP)*world->zone[j].num_shops );
              pack_fread( &world->zone[j].last_shop_vnum, 4, fh );
              for( k = 0; k < world->zone[j].num_shops; k++ ){
                 world->zone[j].shop[k].buy_item_ne = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].buy_item_ne, 0, NAMESIZE );

                 world->zone[j].shop[k].sell_item_ne = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].sell_item_ne, 0, NAMESIZE );

                 world->zone[j].shop[k].refuse_offer = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].refuse_offer, 0, NAMESIZE );

                 world->zone[j].shop[k].shop_afford = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].shop_afford, 0, NAMESIZE );

                 world->zone[j].shop[k].play_afford = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].play_afford, 0, NAMESIZE );

                 world->zone[j].shop[k].buy_success = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].buy_success, 0, NAMESIZE );

                 world->zone[j].shop[k].sell_success = malloc( NAMESIZE );
                 memset( world->zone[j].shop[k].sell_success, 0, NAMESIZE );

                 pack_fread( &world->zone[j].shop[k].vnum, 4, fh );
       
                 pack_fread( &world->zone[j].shop[k].num_items, 4, fh );
                 world->zone[j].shop[k].item = malloc( 4*world->zone[j].shop[k].num_items );
                 pack_fread( world->zone[j].shop[k].item, 4*world->zone[j].shop[k].num_items, fh );
       
                 pack_fread( &world->zone[j].shop[k].prof_sell, 4, fh );
                 pack_fread( &world->zone[j].shop[k].prof_buy, 4, fh );
       
                 pack_fread( &world->zone[j].shop[k].num_bspecs, 4, fh );
                 world->zone[j].shop[k].bspec = malloc( sizeof(BSPEC)*world->zone[j].shop[k].num_bspecs );
                 for( l = 0; l < world->zone[j].shop[k].num_bspecs; l++ ){
                    world->zone[j].shop[k].bspec[l].namelist = malloc( NAMESIZE );
                    memset( world->zone[j].shop[k].bspec[l].namelist, 0, NAMESIZE );

                    pack_fread( &world->zone[j].shop[k].bspec[l].type, 4, fh );
       
                    pack_fread( &t, 4, fh );
                    pack_fread( world->zone[j].shop[k].bspec[l].namelist, t, fh );
                    }
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].buy_item_ne, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].sell_item_ne, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].refuse_offer, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].shop_afford, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].play_afford, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].buy_success, t, fh );
       
                 pack_fread( &t, 4, fh );
                 pack_fread( world->zone[j].shop[k].sell_success, t, fh );
       
                 pack_fread( &world->zone[j].shop[k].temper, 4, fh );
                 pack_fread( &world->zone[j].shop[k].shop_bv, 8, fh );
                 pack_fread( &world->zone[j].shop[k].mobile, 4, fh );
                 pack_fread( &world->zone[j].shop[k].withwho_bv, 8, fh );
       
                 pack_fread( &world->zone[j].shop[k].num_rooms, 4, fh );
                 world->zone[j].shop[k].room = malloc( 4*world->zone[j].shop[k].num_rooms );
                 pack_fread( world->zone[j].shop[k].room, 4*world->zone[j].shop[k].num_rooms, fh );
       
                 pack_fread( &world->zone[j].shop[k].topen[0], 4, fh );
                 pack_fread( &world->zone[j].shop[k].tclose[0], 4, fh );
                 pack_fread( &world->zone[j].shop[k].topen[1], 4, fh );
                 pack_fread( &world->zone[j].shop[k].tclose[1], 4, fh );
                 }

              pack_fread( &world->zone[j].num_tags, 4, fh );
              world->zone[j].tag = malloc( sizeof(TAG) * world->zone[j].num_tags );
              for( k = 0; k < world->zone[j].num_tags; k++ ){
                 world->zone[j].tag[k].str = malloc( NAMESIZE );

                 memset( world->zone[j].tag[k].str, 0, NAMESIZE );

                 pack_fread( &l, 4, fh );
                 pack_fread( world->zone[j].tag[k].str, l, fh );
          
                 pack_fread( &world->zone[j].tag[k].x, 4, fh );
                 pack_fread( &world->zone[j].tag[k].y, 4, fh );
                 pack_fread( &world->zone[j].tag[k].z, 4, fh );
                 }
              }
           pack_fclose( fh );
           rehash_world( world );
           break;

       default:
           pack_fclose( fh );
           return 0;
      }

    return ((ver<<16)|rev);
}

int save_world( char *fn, WORLD *world )
{
    PACKFILE *fh;
    unsigned short ver=YMW_CURRENT_VERSION, rev=YMW_CURRENT_REVISION;
    int j, k, l, m, t;

    if( (fh = pack_fopen( fn, "wb!" )) == NULL )
      return 0;
    pack_fwrite( &ver, 2, fh );
    pack_fwrite( &rev, 2, fh );
    pack_fwrite( &world->num_zones, 4, fh );
    pack_fwrite( &world->last_zone_vnum, 4, fh );
    for( j = 0; j < world->num_zones; j++ ){
       l = strlen( world->zone[j].name );
       pack_fwrite( &l, 4, fh );
       pack_fwrite( world->zone[j].name, l, fh );

       l = strlen( world->zone[j].author );
       pack_fwrite( &l, 4, fh );
       pack_fwrite( world->zone[j].author, l, fh );

       pack_fwrite( &world->zone[j].tint, 4, fh );
       pack_fwrite( &world->zone[j].vnum, 4, fh );
       pack_fwrite( &world->zone[j].life_span, 4, fh );
       pack_fwrite( &world->zone[j].reset_mode, 4, fh );

       pack_fwrite( &world->zone[j].stype, 4, fh );
       pack_fwrite( &world->zone[j].rbv, 8, fh );

       pack_fwrite( &world->zone[j].num_rooms, 4, fh );
       pack_fwrite( &world->zone[j].last_room_vnum, 4, fh );
       for( k = 0; k < world->zone[j].num_rooms; k++ ){
          pack_fwrite( &world->zone[j].room[k].x, 4, fh );
          pack_fwrite( &world->zone[j].room[k].y, 4, fh );
          pack_fwrite( &world->zone[j].room[k].z, 4, fh );

          l = strlen( world->zone[j].room[k].title );
          pack_fwrite( &l, 4, fh );
          pack_fwrite( world->zone[j].room[k].title, l, fh );
   
          l = strlen( world->zone[j].room[k].desc );
          pack_fwrite( &l, 4, fh );
          pack_fwrite( world->zone[j].room[k].desc, l, fh );
   
          pack_fwrite( &world->zone[j].room[k].vnum, 4, fh );
          pack_fwrite( &world->zone[j].room[k].zone, 4, fh );
          pack_fwrite( &world->zone[j].room[k].rbv, 8, fh );
          pack_fwrite( &world->zone[j].room[k].stype, 4, fh );

          pack_fwrite( &world->zone[j].room[k].num_doors, 4, fh );
          for( l = 0; l < world->zone[j].room[k].num_doors; l++ ){
             pack_fwrite( &world->zone[j].room[k].door[l].croom, 4, fh );
             pack_fwrite( &world->zone[j].room[k].door[l].czone, 4, fh );
             pack_fwrite( &world->zone[j].room[k].door[l].cdir, 4, fh );
             pack_fwrite( &world->zone[j].room[k].door[l].typea, 2, fh );
             pack_fwrite( &world->zone[j].room[k].door[l].typeb, 2, fh );
             pack_fwrite( &world->zone[j].room[k].door[l].state, 4, fh );
             pack_fwrite( &world->zone[j].room[k].door[l].key, 4, fh );
             pack_fwrite( &world->zone[j].room[k].door[l].dir, 4, fh );

             m = strlen( world->zone[j].room[k].door[l].desc );
             pack_fwrite( &m, 4, fh );
             pack_fwrite( world->zone[j].room[k].door[l].desc, m, fh );

             m = strlen( world->zone[j].room[k].door[l].keywords );
             pack_fwrite( &m, 4, fh );
             pack_fwrite( world->zone[j].room[k].door[l].keywords, m, fh );
             }
   
          pack_fwrite( &world->zone[j].room[k].num_exd, 4, fh );
          for( l = 0; l < world->zone[j].room[k].num_exd; l++ ){
             m = strlen( world->zone[j].room[k].exd[l].keywords );
             pack_fwrite( &m, 4, fh );
             pack_fwrite( world->zone[j].room[k].exd[l].keywords, m, fh );
   
             m = strlen( world->zone[j].room[k].exd[l].desc );
             pack_fwrite( &m, 4, fh );
             pack_fwrite( world->zone[j].room[k].exd[l].desc, m, fh );
             }

          for( l = 0; l < world->zone[j].room[k].num_cont; l++ )
             if( world->zone[j].room[k].content[l].ifflag )
               world->zone[j].room[k].content[l].ifflag = 1;
          pack_fwrite( &world->zone[j].room[k].num_cont, 4, fh );
          pack_fwrite( world->zone[j].room[k].content, sizeof(RCONTENT)*world->zone[j].room[k].num_cont, fh );
          }

       pack_fwrite( &world->zone[j].num_objects, 4, fh );
       pack_fwrite( &world->zone[j].last_object_vnum, 4, fh );
       for( k = 0; k < world->zone[j].num_objects; k++ ){
          pack_fwrite( &world->zone[j].object[k].vnum, 4, fh );

          l = strlen( world->zone[j].object[k].keywords );
          pack_fwrite( &l, 4, fh );
          pack_fwrite( world->zone[j].object[k].keywords, l, fh );

          l = strlen( world->zone[j].object[k].short_desc );
          pack_fwrite( &l, 4, fh );
          pack_fwrite( world->zone[j].object[k].short_desc, l, fh );

          l = strlen( world->zone[j].object[k].long_desc );
          pack_fwrite( &l, 4, fh );
          pack_fwrite( world->zone[j].object[k].long_desc, l, fh );

          l = strlen( world->zone[j].object[k].action_desc );
          pack_fwrite( &l, 4, fh );
          pack_fwrite( world->zone[j].object[k].action_desc, l, fh );

          pack_fwrite( &world->zone[j].object[k].type, 4, fh );
          pack_fwrite( &world->zone[j].object[k].ebv, 8, fh );
          pack_fwrite( &world->zone[j].object[k].wbv, 8, fh );
          pack_fwrite( world->zone[j].object[k].value, 16, fh );
          pack_fwrite( &world->zone[j].object[k].weight, 4, fh );
          pack_fwrite( &world->zone[j].object[k].cost, 4, fh );
          pack_fwrite( &world->zone[j].object[k].rpd, 4, fh );
          pack_fwrite( &world->zone[j].object[k].num_exd, 4, fh );
          for( m = 0; m < world->zone[j].object[k].num_exd; m++ ){
             l = strlen( world->zone[j].object[k].exd[m].keywords );
             pack_fwrite( &l, 4, fh );
             pack_fwrite( world->zone[j].object[k].exd[m].keywords, l, fh );

             l = strlen( world->zone[j].object[k].exd[m].desc );
             pack_fwrite( &l, 4, fh );
             pack_fwrite( world->zone[j].object[k].exd[m].desc, l, fh );
             }
          pack_fwrite( &world->zone[j].object[k].num_affect, 4, fh );
          for( m = 0; m < world->zone[j].object[k].num_affect; m++ ){
             pack_fwrite( &world->zone[j].object[k].affect[m].location, 4, fh );
             pack_fwrite( &world->zone[j].object[k].affect[m].value, 4, fh );
             }
          }

       pack_fwrite( &world->zone[j].num_mobiles, 4, fh );
       pack_fwrite( &world->zone[j].last_mobile_vnum, 4, fh );
       for( k = 0; k < world->zone[j].num_mobiles; k++ ){
          pack_fwrite( &world->zone[j].mobile[k].vnum, 4, fh );

          l = strlen( world->zone[j].mobile[k].keywords );
          pack_fwrite( &l, 4, fh );
          pack_fwrite( world->zone[j].mobile[k].keywords, l, fh );

          l = strlen( world->zone[j].mobile[k].short_desc );
          pack_fwrite( &l, 4, fh );
          pack_fwrite( world->zone[j].mobile[k].short_desc, l, fh );

          l = strlen( world->zone[j].mobile[k].long_desc );
          pack_fwrite( &l, 4, fh );
          pack_fwrite( world->zone[j].mobile[k].long_desc, l, fh );

          l = strlen( world->zone[j].mobile[k].detail_desc );
          pack_fwrite( &l, 4, fh );
          pack_fwrite( world->zone[j].mobile[k].detail_desc, l, fh );

          pack_fwrite( &world->zone[j].mobile[k].actbv, 8, fh );
          pack_fwrite( &world->zone[j].mobile[k].affbv, 8, fh );
          pack_fwrite( &world->zone[j].mobile[k].alignment, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].typeflag, 1, fh );
          pack_fwrite( &world->zone[j].mobile[k].level, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].thac0, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].ac, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].mhpx, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].mhpy, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].mhpz, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].bhdx, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].bhdy, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].bhdz, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].gold, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].exp, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].loadpos, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].defpos, 4, fh );
          pack_fwrite( &world->zone[j].mobile[k].sex, 1, fh );
          pack_fwrite( &world->zone[j].mobile[k].num_especs, 4, fh );
          pack_fwrite( world->zone[j].mobile[k].espec, sizeof(ESPEC)*world->zone[j].mobile[k].num_especs, fh );
          }

       pack_fwrite( &world->zone[j].num_shops, 4, fh );
       pack_fwrite( &world->zone[j].last_shop_vnum, 4, fh );
       for( k = 0; k < world->zone[j].num_shops; k++ ){
          pack_fwrite( &world->zone[j].shop[k].vnum, 4, fh );

          pack_fwrite( &world->zone[j].shop[k].num_items, 4, fh );
          pack_fwrite( world->zone[j].shop[k].item, 4*world->zone[j].shop[k].num_items, fh );

          pack_fwrite( &world->zone[j].shop[k].prof_sell, 4, fh );
          pack_fwrite( &world->zone[j].shop[k].prof_buy, 4, fh );

          pack_fwrite( &world->zone[j].shop[k].num_bspecs, 4, fh );
          for( l = 0; l < world->zone[j].shop[k].num_bspecs; l++ ){
             pack_fwrite( &world->zone[j].shop[k].bspec[l].type, 4, fh );

             t = strlen( world->zone[j].shop[k].bspec[l].namelist );
             pack_fwrite( &t, 4, fh );
             pack_fwrite( world->zone[j].shop[k].bspec[l].namelist, t, fh );
             }

          t = strlen( world->zone[j].shop[k].buy_item_ne );
          pack_fwrite( &t, 4, fh );
          pack_fwrite( world->zone[j].shop[k].buy_item_ne, t, fh );

          t = strlen( world->zone[j].shop[k].sell_item_ne );
          pack_fwrite( &t, 4, fh );
          pack_fwrite( world->zone[j].shop[k].sell_item_ne, t, fh );

          t = strlen( world->zone[j].shop[k].refuse_offer );
          pack_fwrite( &t, 4, fh );
          pack_fwrite( world->zone[j].shop[k].refuse_offer, t, fh );

          t = strlen( world->zone[j].shop[k].shop_afford );
          pack_fwrite( &t, 4, fh );
          pack_fwrite( world->zone[j].shop[k].shop_afford, t, fh );

          t = strlen( world->zone[j].shop[k].play_afford );
          pack_fwrite( &t, 4, fh );
          pack_fwrite( world->zone[j].shop[k].play_afford, t, fh );

          t = strlen( world->zone[j].shop[k].buy_success );
          pack_fwrite( &t, 4, fh );
          pack_fwrite( world->zone[j].shop[k].buy_success, t, fh );

          t = strlen( world->zone[j].shop[k].sell_success );
          pack_fwrite( &t, 4, fh );
          pack_fwrite( world->zone[j].shop[k].sell_success, t, fh );

          pack_fwrite( &world->zone[j].shop[k].temper, 4, fh );
          pack_fwrite( &world->zone[j].shop[k].shop_bv, 8, fh );
          pack_fwrite( &world->zone[j].shop[k].mobile, 4, fh );
          pack_fwrite( &world->zone[j].shop[k].withwho_bv, 8, fh );

          pack_fwrite( &world->zone[j].shop[k].num_rooms, 4, fh );
          pack_fwrite( world->zone[j].shop[k].room, 4*world->zone[j].shop[k].num_rooms, fh );

          pack_fwrite( &world->zone[j].shop[k].topen[0], 4, fh );
          pack_fwrite( &world->zone[j].shop[k].tclose[0], 4, fh );
          pack_fwrite( &world->zone[j].shop[k].topen[1], 4, fh );
          pack_fwrite( &world->zone[j].shop[k].tclose[1], 4, fh );
          }

       pack_fwrite( &world->zone[j].num_tags, 4, fh );
       for( k = 0; k < world->zone[j].num_tags; k++ ){
          l = strlen( world->zone[j].tag[k].str );
          pack_fwrite( &l, 4, fh );
          pack_fwrite( world->zone[j].tag[k].str, l, fh );
   
          pack_fwrite( &world->zone[j].tag[k].x, 4, fh );
          pack_fwrite( &world->zone[j].tag[k].y, 4, fh );
          pack_fwrite( &world->zone[j].tag[k].z, 4, fh );
          }
       }

    pack_fclose( fh );

    return -1;
}

char cpath[2048];

int pc_cb_tx, pc_cb_ty;
int pc_cb_tot, pc_cb_sofar;

void set_pc_cb_tp()
{
    pc_cb_tx = wherex();
    pc_cb_ty = wherey();
    pc_cb_tot = 0;
    pc_cb_sofar = 0;
}

void pc_cb_t()
{
    float fbf;

    fbf = (float)((float)(pc_cb_sofar)/(float)(pc_cb_tot)*100.);

    gotoxy( pc_cb_tx, pc_cb_ty );
    printf( "%3d%%\n", (int)(fbf) );
}

#define update_pc_cb_disp       \
pc_cb_sofar++;                  \
pc_cb_t();

void create_blank( char *file )
{
    fclose( fopen( file, "wb" ) );
}

char *format_desc( char *data )
{
    FILE *fh;
    char fname[2048], fname2[2048];
    char *ret;
    char *oret;

    if( strlen( data ) < 1 ){
      ret = malloc( 1 );
      ret[0] = '\0';
      return ret;
      }

    strcpy( fname, cpath );
    strcat( fname, "/tmp" );

    strcpy( fname2, cpath );
    strcat( fname2, "/res/fmt.exe ");
    strcat( fname2, fname );
    strcat( fname2, " > " );
    strcat( fname2, fname );
    strcat( fname2, "2" );

    fh = fopen( fname, "wt" );
    fprintf( fh, "%s", data );
    fclose( fh );

    system( fname2 );

    strcpy( fname2, fname );
    strcat( fname2, "2" );
    fh = fopen( fname2, "rt" );
    ret = malloc( filelength(fileno(fh)) );
    oret = ret;
    do{
      fread( ret++, 1, 1, fh );
      } while( !feof(fh) );
    ret[-2] = '\0';
    fclose( fh );

    unlink( fname );
    unlink( fname2 );

    return oret;
}

/* Get Fully Qualified vnum; a = zone vnum, b = thing vnum */
#define get_fq_vnum( a, b )    ((a*1000)+b)

int export_world_mob( char *path, ZONE *zone )
{
    FILE *fh;
    int j;
    char *tmp;
    int positions[]={4, 5, 6, 8};

    fh = fopen( path, "wt" );

    for( j = 0; j < zone->num_mobiles; j++ ){
       fprintf( fh, "#%d\n", get_fq_vnum( zone->vnum, zone->mobile[j].vnum ) );
       fprintf( fh, "%s~\n", zone->mobile[j].keywords );
       fprintf( fh, "%s~\n", zone->mobile[j].short_desc );
       fprintf( fh, "%s\n~\n", zone->mobile[j].long_desc );
       tmp = format_desc( zone->mobile[j].detail_desc );
       fprintf( fh, "%s\n~\n", tmp );
       free( tmp );
       fprintf( fh, "%llu %llu %d S\n", zone->mobile[j].actbv, zone->mobile[j].affbv, zone->mobile[j].alignment );
       fprintf( fh, "%d %d %d %dd%d+%d %dd%d+%d\n", zone->mobile[j].level, zone->mobile[j].thac0, zone->mobile[j].ac, zone->mobile[j].mhpx, zone->mobile[j].mhpy, zone->mobile[j].mhpz, zone->mobile[j].bhdx, zone->mobile[j].bhdy, zone->mobile[j].bhdz );
       fprintf( fh, "%d %d\n", zone->mobile[j].gold, zone->mobile[j].exp );
       fprintf( fh, "%d %d %d\n", positions[zone->mobile[j].loadpos], positions[zone->mobile[j].defpos], zone->mobile[j].sex );
       update_pc_cb_disp
       }

    fprintf( fh, "$\n" );

    fclose( fh );

    return 0;
}

int export_world_obj( char *path, ZONE *zone )
{
    FILE *fh;
    int j, k;
    char *tmp;

    fh = fopen( path, "wt" );

    for( j = 0; j < zone->num_objects; j++ ){
       fprintf( fh, "#%d\n", get_fq_vnum( zone->vnum, zone->object[j].vnum ) );
       fprintf( fh, "%s~\n", zone->object[j].keywords );
       fprintf( fh, "%s~\n", zone->object[j].short_desc );
       fprintf( fh, "%s~\n", zone->object[j].long_desc );
       fprintf( fh, "%s~\n", zone->object[j].action_desc );
       fprintf( fh, "%d %llu %llu\n", zone->object[j].type+1, zone->object[j].ebv, zone->object[j].wbv );
       if( zone->object[j].type+1 == 2  || /* Scrolls and... */
           zone->object[j].type+1 == 10 ){ /* ...Potions */
         fprintf( fh, "%d %d %d %d\n", zone->object[j].value[0], zone->object[j].value[1]-1, zone->object[j].value[2]-1, zone->object[j].value[3]-1 );
         }
       else if( zone->object[j].type+1 == 3 || /* Wands and... */
                zone->object[j].type+1 == 4 ){ /* ...Staffs */
         fprintf( fh, "%d %d %d %d\n", zone->object[j].value[0], zone->object[j].value[1], zone->object[j].value[2], zone->object[j].value[3]-1 );
         }
       else{
         fprintf( fh, "%d %d %d %d\n", zone->object[j].value[0], zone->object[j].value[1], zone->object[j].value[2], zone->object[j].value[3] );
         }
       fprintf( fh, "%d %d %d\n", zone->object[j].weight, zone->object[j].cost, zone->object[j].rpd );
       for( k = 0; k < zone->object[j].num_exd; k++ ){
          fprintf( fh, "E\n" );
          fprintf( fh, "%s~\n", zone->object[j].exd[k].keywords );
          tmp = format_desc( zone->object[j].exd[k].desc );
          fprintf( fh, "%s\n~\n", tmp );
          free( tmp );
          }
       for( k = 0; k < zone->object[j].num_affect; k++ ){
          fprintf( fh, "A\n" );
          fprintf( fh, "%d %d\n", zone->object[j].affect[k].location, zone->object[j].affect[k].value );
          }
       update_pc_cb_disp
       }
    fprintf( fh, "$\n");

    fclose( fh );

    return 0;
}

int export_world_wld( char *path, ZONE *zone )
{
    FILE *fh;
    int j, k;
    char *tmp;

    fh = fopen( path, "wt" );

    for( j = 0; j < zone->num_rooms; j++ ){
       fprintf( fh, "#%d\n", get_fq_vnum( zone->vnum, zone->room[j].vnum ) );
       fprintf( fh, "%s~\n", zone->room[j].title );
       tmp = format_desc( zone->room[j].desc );
       fprintf( fh, "%s\n~\n", tmp );
       free( tmp );
       fprintf( fh, "%d %llu %d\n", zone->vnum, zone->room[j].rbv, zone->room[j].stype );
       for( k = 0; k < zone->room[j].num_doors; k++ ){
          if( !(zone->room[j].door[k].typeb & D_CANT_LEAVE) ){
            fprintf( fh, "D%d\n", zone->room[j].door[k].dir );
            tmp = format_desc( zone->room[j].door[k].desc );
            fprintf( fh, "%s\n~\n", tmp );
            free( tmp );
            fprintf( fh, "%s~\n", zone->room[j].door[k].keywords );
            fprintf( fh, "%d %d %d\n", zone->room[j].door[k].typea, (zone->room[j].door[k].key == -1)?(-1):(get_fq_vnum( zone->vnum, zone->room[j].door[k].key )), get_fq_vnum( zone->room[j].door[k].czone, zone->room[j].door[k].croom ) );
            }
          }
       for( k = 0; k < zone->room[j].num_exd; k++ ){
          fprintf( fh, "E\n" );
          fprintf( fh, "%s~\n", zone->room[j].exd[k].keywords );
          tmp = format_desc( zone->room[j].exd[k].desc );
          fprintf( fh, "%s\n~\n", tmp );
          free( tmp );
          }

       fprintf( fh, "S\n");
       update_pc_cb_disp
       }
    fprintf( fh, "$\n");

    fclose( fh );

    return 0;
}

int export_world_shp( char *path, ZONE *zone )
{
    FILE *fh;
    int j, k;

    fh = fopen( path, "wt" );

    fprintf( fh, "CircleMUD v3.0 Shop File~\n");

    for( j = 0; j < zone->num_shops; j++ ){
       fprintf( fh, "#%d~\n", get_fq_vnum( zone->vnum, zone->shop[j].vnum ) );

       for( k = 0; k < zone->shop[j].num_items; k++ ){
          fprintf( fh, "%d\n", get_fq_vnum( zone->vnum, zone->shop[j].item[k] ) );
          }
       fprintf( fh, "-1\n");

       fprintf( fh, "%f\n", zone->shop[j].prof_sell );
       fprintf( fh, "%f\n", zone->shop[j].prof_buy );

       for( k = 0; k < zone->shop[j].num_bspecs; k++ ){
          fprintf( fh, "%d %s\n", zone->shop[j].bspec[k].type, zone->shop[j].bspec[k].namelist );
          }
       fprintf( fh, "-1\n");

       fprintf( fh, "%%s %s~\n", zone->shop[j].buy_item_ne );
       fprintf( fh, "%%s %s~\n", zone->shop[j].sell_item_ne );
       fprintf( fh, "%%s %s~\n", zone->shop[j].refuse_offer );
       fprintf( fh, "%%s %s~\n", zone->shop[j].shop_afford );
       fprintf( fh, "%%s %s~\n", zone->shop[j].play_afford );
       fprintf( fh, "%%s %s~\n", zone->shop[j].buy_success );
       fprintf( fh, "%%s %s~\n", zone->shop[j].sell_success );

       fprintf( fh, "%d\n", zone->shop[j].temper-1 );
       fprintf( fh, "%llu\n", zone->shop[j].shop_bv );
       fprintf( fh, "%d\n", get_fq_vnum( zone->vnum, zone->shop[j].mobile ) );
       fprintf( fh, "%llu\n", zone->shop[j].withwho_bv );

       for( k = 0; k < zone->shop[j].num_rooms; k++ ){
          fprintf( fh, "%d\n", get_fq_vnum( zone->vnum, zone->shop[j].room[k] ) );
          }
       fprintf( fh, "-1\n");

       fprintf( fh, "%d\n", zone->shop[j].topen[0] );
       fprintf( fh, "%d\n", zone->shop[j].tclose[0] );
       fprintf( fh, "%d\n", zone->shop[j].topen[1] );
       fprintf( fh, "%d\n", zone->shop[j].tclose[1] );

       update_pc_cb_disp
       }
    fprintf( fh, "$~\n");

    fclose( fh );

    return 0;
}

int export_world_zon( char *path, ZONE *zone )
{
    FILE *fh;
    int j, k, km;

    fh = fopen( path, "wt" );

    fprintf( fh, "#%d\n", zone->vnum );
    fprintf( fh, "%s~\n", zone->name );
    fprintf( fh, "%d %d %d\n", get_fq_vnum( zone->vnum, 999 ), zone->life_span, zone->reset_mode );
    fprintf( fh, "*\n* This zone was created by %s.\n", zone->author );

    for( j = 0; j < zone->num_rooms; j++ ){
       if( zone->room[j].num_cont > 0 ){
         fprintf( fh, "*\n* Room number %d, ``%s''\n", get_fq_vnum( zone->vnum, zone->room[j].vnum ), zone->room[j].title );
         for( k = 0; k < zone->room[j].num_cont; k++ ){
            switch( zone->room[j].content[k].type ){
/* I screwed this up in the original list, and now there's not much that
 * I can do about it execpt switch number 0 and 1 here...
 ***/
              case 1: /* Load a Mobile */
                   fprintf( fh, "M %d %d %d %d\n",
                          zone->room[j].content[k].ifflag,
                          get_fq_vnum( zone->vnum, zone->room[j].content[k].vnum ),
                          zone->room[j].content[k].max,
                          get_fq_vnum( zone->vnum, zone->room[j].vnum )
                          );
                   break;
  
              case 0: /* Load an Object */
                   fprintf( fh, "O %d %d %d %d\n",
                          zone->room[j].content[k].ifflag,
                          get_fq_vnum( zone->vnum, zone->room[j].content[k].vnum ),
                          zone->room[j].content[k].max,
                          get_fq_vnum( zone->vnum, zone->room[j].vnum )
                          );
                   break;
  
              case 2: /* Give object to mobile */
                   fprintf( fh, "G %d %d %d\n",
                          zone->room[j].content[k].ifflag,
                          get_fq_vnum( zone->vnum, zone->room[j].content[k].vnum ),
                          zone->room[j].content[k].max
                          );
                   break;
  
              case 3: /* Equip mobile with object */
                   fprintf( fh, "E %d %d %d %d\n",
                          zone->room[j].content[k].ifflag,
                          get_fq_vnum( zone->vnum, zone->room[j].content[k].vnum ),
                          zone->room[j].content[k].max,
                          zone->room[j].content[k].extra
                          );
                   break;
  
              case 4: /* Put an object in an object */
                   fprintf( fh, "P %d %d %d %d\n",
                          zone->room[j].content[k].ifflag,
                          get_fq_vnum( zone->vnum, zone->room[j].content[k].vnum ),
                          zone->room[j].content[k].max,
                          get_fq_vnum( zone->vnum, zone->room[j].content[k].extra )
                          );
                   break;
  
              case 5: /* Remove object from room */
                   fprintf( fh, "R %d %d %d\n",
                          zone->room[j].content[k].ifflag,
                          get_fq_vnum( zone->vnum, zone->room[j].vnum ),
                          get_fq_vnum( zone->vnum, zone->room[j].content[k].vnum )
                          );
                   break;
              }
            }
         }
       km = 0;
       for( k = 0; k < zone->room[j].num_doors; k++ ){
          if( zone->room[j].door[k].state != 0 &&
              !(zone->room[j].door[k].typeb & D_CANT_LEAVE) ){
            km++;
            }
          }
       if( km ){
         if( zone->room[j].num_cont > 0 )
           fprintf( fh, "* Doors for this room:\n");
         else
           fprintf( fh, "*\n* Doors for room number %d, ``%s''\n", get_fq_vnum( zone->vnum, zone->room[j].vnum ), zone->room[j].title );

         for( k = 0; k < zone->room[j].num_doors; k++ ){
            if( zone->room[j].door[k].state != 0 &&
                !(zone->room[j].door[k].typeb & D_CANT_LEAVE) ){
              fprintf( fh, "D 0 %d %d %d\n",
                     get_fq_vnum( zone->vnum, zone->room[j].vnum ),
                     zone->room[j].door[k].dir,
                     zone->room[j].door[k].state
                     );
              }
            }
         }
       update_pc_cb_disp
       }
    fprintf( fh, "S\n$\n");

    fclose( fh );

    return 0;
}

int export_world( char *path, WORLD *world )
{
    char newpath[1024];
    FILE *fh;
    int j;

    set_gfx_mode( GFX_TEXT, 0, 0, 0, 0 );
     
    _set_screen_lines( 50 );

    getwd( cpath );

    printf("Creating base directory...\n");

    chdir( path );

/* Mobiles */
    printf("Creating mobiles directory...\n");
    strcpy( newpath, path );
    strcat( newpath, "\\mob" );
    mkdir( newpath, S_IWUSR );

    printf("Writing mobiles...");
    fflush( stdout );
    set_pc_cb_tp();

    fh = fopen( "mob\\index", "wt" );
    for( j = 0; j < world->num_zones; j++ ){
       fprintf( fh, "%d.mob\n", world->zone[j].vnum );
       pc_cb_tot += world->zone[j].num_mobiles;
       }
    fprintf( fh, "$\n" );
    fclose( fh );

    fh = fopen( "mob\\index.mini", "wt" );
    for( j = 0; j < world->num_zones; j++ ){
       fprintf( fh, "%d.mob\n", world->zone[j].vnum );
       }
    fprintf( fh, "$\n" );
    fclose( fh );

    for( j = 0; j < world->num_zones; j++ ){
       sprintf( newpath, "mob\\%d.mob", world->zone[j].vnum );
       export_world_mob( newpath, &world->zone[j] );
       }

/* Objects */
    printf("Creating objects directory...\n");
    strcpy( newpath, path );
    strcat( newpath, "\\obj" );
    mkdir( newpath, S_IWUSR );

    printf("Writing objects...");
    fflush( stdout );
    set_pc_cb_tp();

    fh = fopen( "obj\\index", "wt" );
    for( j = 0; j < world->num_zones; j++ ){
       fprintf( fh, "%d.obj\n", world->zone[j].vnum );
       pc_cb_tot += world->zone[j].num_objects;
       }
    fprintf( fh, "$\n" );
    fclose( fh );

    fh = fopen( "obj\\index.mini", "wt" );
    for( j = 0; j < world->num_zones; j++ ){
       fprintf( fh, "%d.obj\n", world->zone[j].vnum );
       }
    fprintf( fh, "$\n" );
    fclose( fh );

    for( j = 0; j < world->num_zones; j++ ){
       sprintf( newpath, "obj\\%d.obj", world->zone[j].vnum );
       export_world_obj( newpath, &world->zone[j] );
       }

/* Shops */
    printf("Creating shops directory...\n");
    strcpy( newpath, path );
    strcat( newpath, "\\shp" );
    mkdir( newpath, S_IWUSR );

    printf("Writing shops...");
    fflush( stdout );
    set_pc_cb_tp();

    fh = fopen( "shp\\index", "wt" );
    for( j = 0; j < world->num_zones; j++ ){
       fprintf( fh, "%d.shp\n", world->zone[j].vnum );
       pc_cb_tot += world->zone[j].num_shops;
       }
    fprintf( fh, "$\n" );
    fclose( fh );

    fh = fopen( "shp\\index.mini", "wt" );
    for( j = 0; j < world->num_zones; j++ ){
       fprintf( fh, "%d.shp\n", world->zone[j].vnum );
       }
    fprintf( fh, "$\n" );
    fclose( fh );

    for( j = 0; j < world->num_zones; j++ ){
       sprintf( newpath, "shp\\%d.shp", world->zone[j].vnum );
       export_world_shp( newpath, &world->zone[j] );
       }

/* World (rooms) */
    printf("Creating maps directory...\n");
    strcpy( newpath, path );
    strcat( newpath, "\\wld" );
    mkdir( newpath, S_IWUSR );

    printf("Writing maps...");
    fflush( stdout );
    set_pc_cb_tp();

    fh = fopen( "wld\\index", "wt" );
    for( j = 0; j < world->num_zones; j++ ){
       fprintf( fh, "%d.wld\n", world->zone[j].vnum );
       pc_cb_tot += world->zone[j].num_rooms;
       }
    fprintf( fh, "$\n" );
    fclose( fh );

    fh = fopen( "wld\\index.mini", "wt" );
    for( j = 0; j < world->num_zones; j++ ){
       fprintf( fh, "%d.wld\n", world->zone[j].vnum );
       }
    fprintf( fh, "$\n" );
    fclose( fh );

    for( j = 0; j < world->num_zones; j++ ){
       sprintf( newpath, "wld\\%d.wld", world->zone[j].vnum );
       export_world_wld( newpath, &world->zone[j] );
       }

/* Zone scripts */
    printf("Creating zones directory...\n");
    strcpy( newpath, path );
    strcat( newpath, "\\zon" );
    mkdir( newpath, S_IWUSR );

    printf("Writing zones...");
    fflush( stdout );
    set_pc_cb_tp();

    fh = fopen( "zon\\index", "wt" );
    for( j = 0; j < world->num_zones; j++ ){
       fprintf( fh, "%d.zon\n", world->zone[j].vnum );
       pc_cb_tot += world->zone[j].num_rooms;
       }
    fprintf( fh, "$\n" );
    fclose( fh );

    fh = fopen( "zon\\index.mini", "wt" );
    for( j = 0; j < world->num_zones; j++ ){
       fprintf( fh, "%d.zon\n", world->zone[j].vnum );
       }
    fprintf( fh, "$\n" );
    fclose( fh );

    for( j = 0; j < world->num_zones; j++ ){
       sprintf( newpath, "zon\\%d.zon", world->zone[j].vnum );
       export_world_zon( newpath, &world->zone[j] );
       }

    chdir( cpath );

    return -1;
}
